//+------------------------------------------------------------------+ 
//|   TRO_TRADE_LINES_ohlm                                           | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window

extern bool   Show.Boxes  = true ;
extern bool   Show.Labels = true ;
extern int    ShiftLabel  =  20 ;


extern int myPeriod = 0 ;
extern int myShift  = 1 ;



extern int    Line_Style    = STYLE_DOT ;
extern int    Line_Width    = 1 ;

extern int    Line_Style_W1    = STYLE_SOLID ;
extern int    Line_Width_W1    = 2 ;

  
extern color  Line_Color_Hi        = Red ;
extern color  Line_Color_Mid       = Magenta ; 
extern color  Line_Color_Lo        = DodgerBlue ;
extern color  Line_Color_Open    = White ;


string lbl[15], lbl2[15];
int n, j, i ;

string symbol, tChartPeriod, ShortName , TAG , text;  

int    digits, period, win, BarShift ; 

double point ;

double    HHprice, LLprice, TRIGGER, HHtrigger, LLtrigger, D1_Open, W1_Open, W1_High, W1_Low, D1_pMid ;
datetime DateTime ; 
      
//+------------------------------------------------------------------+

int init()
{
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }  

   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   TAG          =  "troTL" ;
   ShortName    =  TAG+symbol+period+myShift  ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
    

   ObDeleteObjectsByPrefix(ShortName);  
  
   TRO() ;
   
   return(0);
  }
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
      
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;
return(0);
}
  
//+------------------------------------------------------------------+
int start()
{

n       = 10;
 
j       = 0 ;
 
HHprice = iHigh(symbol,PERIOD_D1,myShift);  
LLprice = iLow(symbol,PERIOD_D1,myShift);  
D1_Open = iOpen(symbol,PERIOD_D1,0);  


D1_pMid = ( HHprice + LLprice ) * 0.50 ;
D1_pMid = NormalizeDouble(D1_pMid,digits) ;

DateTime  = iTime(symbol,PERIOD_D1,myShift) ; 

 
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(LLprice ,lbl[j], Line_Color_Lo , Line_Style , Line_Width, DateTime, "Daily Low["+myShift+"]" ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(HHprice ,lbl[j], Line_Color_Hi , Line_Style , Line_Width, DateTime, "Daily High["+myShift+"]"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(D1_pMid ,lbl[j], Line_Color_Mid , Line_Style , Line_Width, DateTime, "MidPoint["+myShift+"]"   ) ;



DateTime  = iTime(symbol,PERIOD_D1,0) ; 
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(D1_Open ,lbl[j], Line_Color_Open , Line_Style , Line_Width, DateTime, "Daily Open" ) ; 

DateTime  = iTime(symbol,PERIOD_W1,0) ;  
BarShift  = iBarShift(symbol,PERIOD_W1,Time[0],true); 
W1_Open   = iOpen(symbol,PERIOD_W1,BarShift); 
W1_High   = iHigh(symbol,PERIOD_W1,myShift); 
W1_Low    = iLow(symbol,PERIOD_W1,myShift); 

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_Open   ,lbl[j], Line_Color_Open , Line_Style_W1  , Line_Width_W1 , DateTime, "Weekly Open"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_High   ,lbl[j], Line_Color_Hi , Line_Style_W1  , Line_Width_W1 , DateTime, "Weekly High["+myShift+"]"     ) ;
 
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_Low   ,lbl[j], Line_Color_Lo , Line_Style_W1  , Line_Width_W1 , DateTime, "Weekly Low["+myShift+"]"     ) ;
   

return(0);
}
 

//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type, int width, datetime TimeBar, string text)
{

         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            

            ObjectSet(name, OBJPROP_STYLE, type);

            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);           
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            
            ObjectSet(name, OBJPROP_STYLE, type);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);             
         }
 
 
 
   if(Show.Labels)
   {         
      string Obj0002 = name+"linelbl" ;
      
      ObjectDelete(Obj0002);
      
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, Time[ShiftLabel], lvl);
         ObjectSetText(Obj0002,text , 8, "Arial", Col);
      }
      else
      {
         ObjectMove(Obj0002, 0, Time[ShiftLabel], lvl);
      } // if 
                 
   } // if   

   if(Show.Boxes)
   {  
     string dName = name+"boxes" ;
     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],lvl);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,Col);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],lvl);
      } 
   } // if    
 
}
  

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 
/*

 Comment("DateTime= ", TimeToStr(DateTime) ) ;
 
 */